package eu.mhsl.minenet.minigames.instance.game.stateless.types.anvilRun;

import eu.mhsl.minenet.minigames.instance.game.stateless.StatelessGame;
import eu.mhsl.minenet.minigames.score.LastWinsScore;
import eu.mhsl.minenet.minigames.instance.Dimension;
import eu.mhsl.minenet.minigames.world.generator.terrain.CircularPlateTerrainGenerator;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.entity.Entity;
import net.minestom.server.entity.EntityType;
import net.minestom.server.entity.metadata.other.FallingBlockMeta;
import net.minestom.server.event.player.PlayerMoveEvent;
import net.minestom.server.instance.block.Block;
import org.jetbrains.annotations.NotNull;

import java.util.concurrent.CompletableFuture;

class AnvilRun extends StatelessGame {

    final int radius;

    public AnvilRun(int radius, int pvpEnabled) {
        super(Dimension.THE_END.key, "Deathcube", new LastWinsScore());
        this.radius = radius;
        this.setGenerator(new CircularPlateTerrainGenerator(radius).setPlateHeight(50));
    }

    @Override
    protected void onLoad(@NotNull CompletableFuture<Void> callback) {
        for(int x = -radius; x <= radius; x++) {
            for (int z = -radius; z <= radius; z++) {
                if(new Pos(x, 0, z).distance(new Pos(0, 0, 0)) > radius) continue;

                int height = super.rnd.nextInt(100, 500);
                Entity anvil = new Entity(EntityType.FALLING_BLOCK);
                ((FallingBlockMeta) anvil.getEntityMeta()).setBlock(Block.ANVIL);
                anvil.setNoGravity(true);

            }
        }
    }

    @Override
    protected void onStart() {
        super.onStart();

        // Liste mit anvils
    }

    @Override
    protected void onPlayerMove(@NotNull PlayerMoveEvent playerMoveEvent) {
        super.onPlayerMove(playerMoveEvent);
        if(isBeforeBeginning && playerMoveEvent.getNewPosition().y() < 48.5) {
            playerMoveEvent.setCancelled(true);
            playerMoveEvent.getPlayer().teleport(getSpawn());
        }
        if(playerMoveEvent.getNewPosition().y() < 48.5) getScore().insertResult(playerMoveEvent.getPlayer());
    }

    @Override
    public Pos getSpawn() {
        return new Pos(0, 0, 30);
    }
}
